package org.yaoqiang.bpmn.model.elements.conversations;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLTextElements;
import org.yaoqiang.bpmn.model.elements.core.common.CorrelationKeys;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;

/**
 * ConversationNode
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public abstract class ConversationNode extends BaseElement {

	private static final long serialVersionUID = 7793959486508048448L;

	public ConversationNode(XMLElement parent, String name) {
		super(parent, name);
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		XMLTextElements refParticipantRefs = new XMLTextElements(this, "participantRef");
		XMLTextElements refMessageFlowRefs = new XMLTextElements(this, "messageFlowRef");
		CorrelationKeys refCorrelationKeys = new CorrelationKeys(this);

		super.fillStructure();
		add(attrName);
		add(refParticipantRefs);
		add(refMessageFlowRefs);
		add(refCorrelationKeys);
	}

	public final String getName() {
		return get("name").toValue();
	}
	
	public final void setName(String name) {
		set("name", name);
	}
}
