package org.yaoqiang.bpmn.model.elements.data;

import org.yaoqiang.bpmn.model.elements.XMLAttribute;
import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLTextElements;
import org.yaoqiang.bpmn.model.elements.core.foundation.BaseElement;

/**
 * OutputSet
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class OutputSet extends BaseElement {

	private static final long serialVersionUID = 6181385034937225256L;

	public OutputSet(XMLElement parent) {
		super(parent, "outputSet");
	}

	protected void fillStructure() {
		XMLAttribute attrName = new XMLAttribute(this, "name");
		XMLTextElements refDataOutputRefs = new XMLTextElements(this, "dataOutputRefs");
		XMLTextElements refOptionalOutputRefs = new XMLTextElements(this, "optionalOutputRefs");
		XMLTextElements refWhileExecutingOutputRefs = new XMLTextElements(this, "whileExecutingOutputRefs");
		XMLTextElements refInputSetRefs = new XMLTextElements(this, "inputSetRefs");

		super.fillStructure();
		add(attrName);
		add(refDataOutputRefs);
		add(refOptionalOutputRefs);
		add(refWhileExecutingOutputRefs);
		add(refInputSetRefs);
	}

	public final XMLTextElements getDataOutputRefs() {
		return (XMLTextElements) get("dataOutputRefs");
	}

}
